#include <iostream>
#include <vector>

using ll = long long;
using ld = long double;

using namespace std;

void solve() {
    int n, m;
    cin >> n >> m;
    vector<vector<int>> rows(n, vector<int> (6));
    for (int i = 0; i < n; i++) {
        string s;
        cin >> s;
        for (int j = 0; j < 6; j++) {
            if (s[j] == 'X')
                rows[i][j] = 1;
            else
                rows[i][j] = 0;
        }
    }
    vector<vector<int>> ans(n, vector<int> (6, 0));
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < 3; j++) {
            if (rows[i][j]) {
                ans[i][j] = 1;
                if (rows[i][5 - j])
                    ans[i][5 - j] = 1;
                else {
                    ans[i][5 - j] = 1;
                    m--;
                }
            } else {
                if (rows[i][5 - j]) {
                    ans[i][5 - j] = 1;
                    ans[i][j] = 1;
                    m--;
                }
            }
        }
    }
    if (m < 0) {
        cout << "Impossible";
        return;
    }
    for (int i = 0; i < n; i++) {
        if (m <= 0)
            break;
        for (int j = 0; j < 3; j++) {
            if (m <= 0)
                break;
            if (!ans[i][j] && !ans[i][5 - j]) {
                ans[i][j] = 1;
                ans[i][5 - j] = 1;
                m -= 2;
            }
        }
    }
    if (m < 0) {
        cout << "Impossible";
        return;
    }
    for (int i = 0; i < n; i++) {
        for (int x : ans[i]) {
            if (x)
                cout << 'X';
            else
                cout << '.';
        }
        cout << '\n';
    }
}

int main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    solve();
    return 0;
}
