#pragma GCC optimize("Ofast")

#include <iostream>
#include <vector>

using ll = long long;
using ld = long double;

using namespace std;

void solve() {
    int h, w;
    cin >> h >> w;
    vector<vector<int>> matrix(h, vector<int> (w));
    for (int i = 0; i < h; i++) {
        for (int j = 0; j < w; j++)
            cin >> matrix[i][j];
    }
    ll arr[w][1 << h];
    for (int mask = 1; mask < (1 << h); mask++) {
        for (int i = 0; i < w; i++) {
            arr[i][mask] = 0;
            for (int j = 0; j < h; j++) {
                if (mask & (1 << j))
                    arr[i][mask] += matrix[j][i];
            }
        }
    }
    ll s;
    cin >> s;
    for (int mask = 1; mask < (1 << h); mask++) {
        vector<ll> v(w, 0);
        for (int i = 0; i < w; i++)
            v[i] = arr[i][mask];
        for (int mask2 = 1; mask2 < (1 << w); mask2++) {
            ll sum = 0;
            for (int i = 0; i < w; i++) {
                if (mask2 & (1 << i))
                    sum += v[i];
                if (sum > s)
                    break;
            }
            if (sum == s) {
                cout << "YES\n";
                vector<pair<int, int>> operations;
                int k = 0;
                for (int i = 0; i < h; i++) {
                    if (!(mask & (1 << i))) {
                        operations.emplace_back(1, i + 1);
                        k++;
                    }
                }
                k = 0;
                for (int i = 0; i < w; i++) {
                    if (!(mask2 & (1 << i))) {
                        operations.emplace_back(2, i + 1);
                        k++;
                    }
                }
                cout << operations.size() << '\n';
                for (auto [t, i] : operations)
                    cout << t << ' ' << i << '\n';
                return;
            }
        }
    }
    cout << "NO";
}

int main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    solve();
    return 0;
}
