#include <iostream>
#include <vector>
#include <set>

using ll = long long;
using ld = long double;

using namespace std;

bool is_prime(int x) {
    if (x == 1)
        return false;
    for (int i = 2; i < x; i++) {
        if (!(x % i))
            return false;
    }
    return true;
}

void solve() {
    int n;
    cin >> n;
    vector<int> v(n);
    for (int& x : v)
        cin >> x;
    vector<int> color(n, 0);
    vector<bool> end(n, false), handled(n, false);
    end[0] = true;
    bool b = false;
    for (int i = 0; i < n; i++) {
        bool flag = false;
        for (int j = 0; j < n; j++) {
            if (handled[j])
                continue;
            if (!end[j])
                continue;
            for (int k = 0; k < n; k++) {
                if (k == j)
                    continue;
                if ((v[j] % v[k] == 0 && is_prime(v[j] / v[k])) || (v[k] % v[j] == 0 && is_prime(v[k] / v[j]))) {
                    color[k] = !color[j];
                    end[k] = true;
                }
            }
            flag = true;
            break;
        }
        if (!flag) {
            if (b) {
                
            } else {
                b = true;
                end[i] = true;
                i--;
            }
        } else {
            b = false;
        }
    }
    for (int c : color)
        cout << c + 1 << ' ';
}

int main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    solve();
    return 0;
}
