#include <iostream>
#include <vector>
#include <map>
#include <set>
#include <unordered_map>
#include <unordered_set>
#include <queue>

using ll = long long;
using ld = long double;

using namespace std;

bool is_prime(int x) {
    if (x == 1)
        return false;
    for (int i = 2; i * i <= x; i++) {
        if (!(x % i))
            return false;
    }
    return true;
}

void solve() {
    int n;
    cin >> n;
    vector<int> v(n);
    for (int& x : v)
        cin >> x;
    vector<int> color(n, 0);
    set<int> st;
    for (int i = 0; i < n; i++) {
        for (int x : st) {
            if ((x % v[i] == 0 && is_prime(x / v[i])) || (v[i] % x == 0 && is_prime(v[i] / x))) {
                color[i] = 1;
                break;
            }
        }
        if (color[i] == 0)
            st.insert(v[i]);
    }
    for (int c : color)
        cout << c + 1 << ' ';
}

int main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    solve();
    return 0;
}
