#include <iostream>
#include <vector>
#include <set>

using ll = long long;
using ld = long double;

using namespace std;

bool is_prime(int x) {
    for (int i = 2; i < x; i++) {
        if (!(x % i))
            return false;
    }
    return true;
}

void solve() {
    int n;
    cin >> n;
    vector<int> v(n);
    for (int& x : v)
        cin >> x;
    vector<int> color(n, 1);
    set<int> st;
    for (int i = 0; i < n; i++) {
        int x = v[i];
        vector<int> divisors;
        for (int j = 0; j < i; j++) {
            if (color[j] == 2)
                continue;
            if (x % v[j] == 0 && is_prime(x / v[j])) {
                color[i] = 2;
                break;
            }
        }
    }
    for (int c : color)
        cout << c << ' ';
}

int main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    solve();
    return 0;
}
