#include <iostream>
#include <vector>

using ll = long long;
using ld = long double;

using namespace std;

void solve() {
    ll n, m;
    cin >> n >> m;
    vector<vector<bool>> rows(n, vector<bool> (6, false));
    for (int i = 0; i < n; i++) {
        string s;
        cin >> s;
        for (int j = 0; j < 6; j++) {
            if (s[j] == 'X')
                rows[i][j] = true;
        }
    }
    vector<vector<bool>> ans(n, vector<bool> (6, false));
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < 3; j++) {
            if (rows[i][j] == rows[i][5 - j])
                continue;
            rows[i][j] = true;
            rows[i][5 - j] = true;
            m--;
        }
    }
    if (m < 0) {
        cout << "Impossible";
        return;
    }
    for (int i = 0; i < n; i++) {
        if (m <= 0)
            break;
        for (int j = 0; j < 3; j++) {
            if (m <= 0)
                break;
            if (!rows[i][j] && !rows[i][5 - j]) {
                rows[i][j] = true;
                rows[i][5 - j] = true;
                m -= 2;
            }
        }
    }
    if (m < 0) {
        cout << "Impossible";
        return;
    }
    for (int i = 0; i < n; i++) {
        for (bool x : rows[i]) {
            if (x)
                cout << 'X';
            else
                cout << '.';
        }
        cout << '\n';
    }
}

int main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    solve();
    return 0;
}
