#include <iostream>
#include <vector>

using ll = long long;
using ld = long double;

using namespace std;

void solve() {
    int n;
    cin >> n;
    vector<int> v(n);
    for (int& x : v)
        cin >> x;
    ll ans = 0;
    int r = 0;
    bool inv = false;
    for (; r < n - 1; r++) {
        if (v[r] == v[r + 1])
            break;
        if (inv && v[r + 1] >= v[r])
            break;
        if (!inv && v[r + 1] < v[r])
            inv = true;
    }
    int l = 0;
    while (l < n) {
        if (l == r) {
            while (l < n - 1 && v[l] == v[l + 1]) {
                l++;
                r++;
                ans++;
            }
            for (; r < n - 1; r++) {
                if (v[r] == v[r + 1])
                    break;
                if (inv && v[r + 1] >= v[r])
                    break;
                if (!inv && v[r + 1] < v[r])
                    inv = true;
            }
        }
        ans += r - l + 1;
        l++;
    }
    cout << ans;
}

int main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    solve();
    return 0;
}
